//+------------------------------------------------------------------+
//|                                                          MAR.mq4 |
//|                               Copyright  2014, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 LimeGreen
#property indicator_color2 Orange
#property indicator_color3 Orange
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2


extern int timeFrame = 0;        // Time frame to use
extern int Length=8;
extern int Method=0;             // 0 - SMA
                                 // 1 - EMA
                                 // 2 - SMMA
                                 // 3 - LWMA
extern double Round=2;
extern int    Price=0;           // Applied price
                                 // 0 - Close
                                 // 1 - Open
                                 // 2 - High
                                 // 3 - Low
                                 // 4 - Median
                                 // 5 - Typical
                                 // 6 - Weighted  
extern int BarsToCalculate = 0;                                 


double MAR[],MARda[],MARdb[],slope[] ;
double MA[], MovAle[];
double MaRo;
string indicatorFileName;
bool   returnBars;

int init()
{
 IndicatorShortName("Rounded ma MTF");
 IndicatorBuffers(6);
 SetIndexBuffer(0,MAR);
 SetIndexBuffer(1,MARda);
 SetIndexBuffer(2,MARdb);
 SetIndexBuffer(3,MA);
 SetIndexBuffer(4,MovAle);
 SetIndexBuffer(5,slope);
         indicatorFileName = WindowExpertName();
         returnBars        = timeFrame==-999;  if (returnBars) return(0);
         if (timeFrame==0)   timeFrame= Period(); 
 MaRo=Round*Point;

 return(0);
}

int deinit()
{

 return(0);
}

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { MAR[0] = MathMin(limit+1,Bars-1); return(0); }
           if (timeFrame!=Period())
           {
               limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,-999,0,0)*timeFrame/Period()));
               if (BarsToCalculate>0) limit = MathMin(limit,BarsToCalculate);
               if (slope[limit]==-1) ClearPoint(limit,MARda,MARdb);
               for (int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);
                     MAR[i]    = iCustom(NULL,timeFrame,indicatorFileName,0,Length,Method,Round,Price,BarsToCalculate,0,y);
                     slope[i]  = iCustom(NULL,timeFrame,indicatorFileName,0,Length,Method,Round,Price,BarsToCalculate,5,y);
                     if (slope[i] == -1) PlotPoint(i,MARda,MARdb,MAR);
               }                   
               return(0);
           }

   //
   //
   //
   //
   //
   
   if (BarsToCalculate>0) limit = MathMin(limit,BarsToCalculate);
   if (slope[limit]==-1) ClearPoint(limit,MARda,MARdb);
   for(int pos=limit; pos>=0; pos--)
   {
      MA[pos]=iMA(NULL, 0, Length, 0, Method, Price, pos);
  
      if (MA[pos]>MA[pos+1]+MaRo || MA[pos]<MA[pos+1]-MaRo || MA[pos]>MAR[pos+1]+MaRo || MA[pos]<MAR[pos+1]-MaRo || (MA[pos]>MAR[pos+1] && MovAle[pos+1]==1.) || (MA[pos]<MAR[pos+1] && MovAle[pos+1]==-1.))
            MAR[pos]=MA[pos];
      else  MAR[pos]=MAR[pos+1];
      if (MAR[pos]<MAR[pos+1])
         MovAle[pos]=-1.;
      else
         if (MAR[pos]>MAR[pos+1])
               MovAle[pos]=1.;
         else  MovAle[pos]=MovAle[pos+1];
         MARda[pos] = EMPTY_VALUE;
         MARdb[pos] = EMPTY_VALUE;
         slope[pos] = slope[pos+1];
            if (MAR[pos]>MAR[pos+1]) slope[pos] =  1;
            if (MAR[pos]<MAR[pos+1]) slope[pos] = -1;
            if (slope[pos]==-1) PlotPoint(pos,MARda,MARdb,MAR);
   } 
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void ClearPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}